// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'hlDipSwitch.pas' rev: 6.00

#ifndef hlDipSwitchHPP
#define hlDipSwitchHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Hldipswitch
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum ThlBorderStyle { bsLowered, bsNone, bsRaised, bsSingle };
#pragma option pop

#pragma option push -b-
enum ThlSwitchOrientation { soVertical, soHorizontal };
#pragma option pop

#pragma option push -b-
enum ThlSwitchStyleKind { ssDrag, ssClickThumb, ssClickTrack };
#pragma option pop

typedef Set<ThlSwitchStyleKind, ssDrag, ssClickTrack>  ThlSwitchStyle;

#pragma option push -b-
enum ThlDipSwitchPanelLabelPosition { lpLeftTop, lpLeftBottom, lpRightTop, lpRightBottom };
#pragma option pop

#pragma option push -b-
enum ThlDipSwitchPanelNumbersPosition { npTop, npBottom };
#pragma option pop

class DELPHICLASS ThlPanel;
class PASCALIMPLEMENTATION ThlPanel : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	ThlBorderStyle FBorderStyle;
	int FBorderWidth;
	Graphics::TColor FBrightHighlightColor;
	Graphics::TColor FDarkShadowColor;
	Graphics::TColor FFaceColor;
	Graphics::TColor FHighlightColor;
	Classes::TNotifyEvent FOnChange;
	Graphics::TColor FShadowColor;
	void __fastcall SetBorderStyle(ThlBorderStyle Value);
	void __fastcall SetBrightHighlightColor(Graphics::TColor Value);
	void __fastcall SetDarkShadowColor(Graphics::TColor Value);
	void __fastcall SetFaceColor(Graphics::TColor Value);
	void __fastcall SetHighlightColor(Graphics::TColor Value);
	void __fastcall SetShadowColor(Graphics::TColor Value);
	
public:
	__fastcall ThlPanel(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property int BorderWidth = {read=FBorderWidth, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	
__published:
	__property ThlBorderStyle BorderStyle = {read=FBorderStyle, write=SetBorderStyle, default=0};
	__property Graphics::TColor BrightHighlightColor = {read=FBrightHighlightColor, write=SetBrightHighlightColor, default=-2147483628};
	__property Graphics::TColor DarkShadowColor = {read=FDarkShadowColor, write=SetDarkShadowColor, default=0};
	__property Graphics::TColor FaceColor = {read=FFaceColor, write=SetFaceColor, default=-2147483633};
	__property Graphics::TColor HighlightColor = {read=FHighlightColor, write=SetHighlightColor, default=-2147483633};
	__property Graphics::TColor ShadowColor = {read=FShadowColor, write=SetShadowColor, default=-2147483632};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~ThlPanel(void) { }
	#pragma option pop
	
};


class DELPHICLASS ThlBackgroundParams;
class PASCALIMPLEMENTATION ThlBackgroundParams : public ThlPanel 
{
	typedef ThlPanel inherited;
	
public:
	__fastcall ThlBackgroundParams(void);
	
__published:
	__property FaceColor  = {default=-2147483628};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~ThlBackgroundParams(void) { }
	#pragma option pop
	
};


class DELPHICLASS ThlThumbParams;
class PASCALIMPLEMENTATION ThlThumbParams : public ThlPanel 
{
	typedef ThlPanel inherited;
	
private:
	int FLength;
	bool FRipples;
	void __fastcall SetRipples(bool Value);
	void __fastcall SetLength(int Value);
	
public:
	__fastcall ThlThumbParams(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property BorderStyle  = {default=2};
	__property bool Ripples = {read=FRipples, write=SetRipples, default=1};
	__property int Length = {read=FLength, write=SetLength, default=20};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~ThlThumbParams(void) { }
	#pragma option pop
	
};


class DELPHICLASS ThlDipSwitch;
class PASCALIMPLEMENTATION ThlDipSwitch : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	bool FAllowArrowKeys;
	ThlBackgroundParams* FBackground;
	int FMargin;
	int FNumPositions;
	Classes::TNotifyEvent FOnChange;
	ThlSwitchOrientation FOrientation;
	int FPosition;
	bool FShowFocusRect;
	ThlSwitchStyle FSwitchStyle;
	ThlThumbParams* FThumb;
	bool MouseDownInThumb;
	#pragma pack(push, 1)
	Types::TRect ThumbRect;
	#pragma pack(pop)
	
	int MouseTimerID;
	bool MouseWasDragged;
	void __fastcall CheckOSVersion(void);
	Types::TRect __fastcall GetTrackRect();
	int __fastcall MouseToPos(int X, int Y);
	void __fastcall SetBackground(ThlBackgroundParams* Value);
	void __fastcall SetMargin(int Value);
	void __fastcall SetNumPositions(int Value);
	void __fastcall SetOrientation(ThlSwitchOrientation Value);
	void __fastcall SetPosition(int Value);
	void __fastcall SetSwitchStyle(ThlSwitchStyle Value);
	void __fastcall SetThumb(ThlThumbParams* Value);
	void __fastcall SetThumbRect(void);
	
protected:
	DYNAMIC void __fastcall ChangeScale(int M, int D);
	void __fastcall DoDrawFocusRect(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall Paint(void);
	void __fastcall PaintBackground(void);
	void __fastcall PaintThumb(void);
	void __fastcall ParamsChanged(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMSysColorChange(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMKillFocus(Messages::TWMKillFocus &Msg);
	HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &Msg);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Msg);
	
public:
	__fastcall virtual ThlDipSwitch(Classes::TComponent* AOwner);
	__fastcall virtual ~ThlDipSwitch(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool AllowArrowKeys = {read=FAllowArrowKeys, write=FAllowArrowKeys, default=1};
	__property ThlBackgroundParams* Background = {read=FBackground, write=SetBackground};
	__property int Margin = {read=FMargin, write=SetMargin, default=1};
	__property int NumPositions = {read=FNumPositions, write=SetNumPositions, default=2};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property ThlSwitchOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
	__property int Position = {read=FPosition, write=SetPosition, default=0};
	__property bool ShowFocusRect = {read=FShowFocusRect, write=FShowFocusRect, default=1};
	__property ThlSwitchStyle SwitchStyle = {read=FSwitchStyle, write=SetSwitchStyle, default=5};
	__property ThlThumbParams* Thumb = {read=FThumb, write=SetThumb};
	__property Enabled  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=0};
	__property Visible  = {default=1};
	__property OnContextPopup ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall ThlDipSwitch(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	#pragma option pop
	
};


class DELPHICLASS ThlDipSwitchWrapper;
class PASCALIMPLEMENTATION ThlDipSwitchWrapper : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAllowArrowKeys;
	ThlBackgroundParams* FBackground;
	Controls::TCursor FCursor;
	int FHeight;
	int FMargin;
	int FNumPositions;
	Classes::TNotifyEvent FOnChange;
	bool FShowFocusRect;
	ThlSwitchStyle FSwitchStyle;
	ThlThumbParams* FThumb;
	int FWidth;
	void __fastcall SetAllowArrowKeys(bool Value);
	void __fastcall SetBackground(ThlBackgroundParams* Value);
	void __fastcall SetCursor(Controls::TCursor Value);
	void __fastcall SetHeight(int Value);
	void __fastcall SetMargin(int Value);
	void __fastcall SetNumPositions(int Value);
	void __fastcall SetShowFocusRect(bool Value);
	void __fastcall SetSwitchStyle(ThlSwitchStyle Value);
	void __fastcall SetThumb(ThlThumbParams* Value);
	void __fastcall SetWidth(int Value);
	
protected:
	void __fastcall ParamsChanged(System::TObject* Sender);
	
public:
	__fastcall ThlDipSwitchWrapper(void);
	__fastcall virtual ~ThlDipSwitchWrapper(void);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	
__published:
	__property bool AllowArrowKeys = {read=FAllowArrowKeys, write=SetAllowArrowKeys, default=1};
	__property ThlBackgroundParams* Background = {read=FBackground, write=SetBackground};
	__property Controls::TCursor Cursor = {read=FCursor, write=SetCursor, default=0};
	__property int Height = {read=FHeight, write=SetHeight, nodefault};
	__property int Margin = {read=FMargin, write=SetMargin, default=1};
	__property int NumPositions = {read=FNumPositions, write=SetNumPositions, default=2};
	__property bool ShowFocusRect = {read=FShowFocusRect, write=SetShowFocusRect, default=1};
	__property ThlSwitchStyle SwitchStyle = {read=FSwitchStyle, write=SetSwitchStyle, default=5};
	__property ThlThumbParams* Thumb = {read=FThumb, write=SetThumb};
	__property int Width = {read=FWidth, write=SetWidth, nodefault};
};


class DELPHICLASS ThlDipSwitchPanelLabels;
class PASCALIMPLEMENTATION ThlDipSwitchPanelLabels : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TFont* FFont;
	AnsiString FLabel;
	ThlDipSwitchPanelLabelPosition FLabelPosition;
	bool FLabelVisible;
	bool FNumbersVisible;
	ThlDipSwitchPanelNumbersPosition FNumbersPosition;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall SetLabel(AnsiString Value);
	void __fastcall SetLabelPosition(ThlDipSwitchPanelLabelPosition Value);
	void __fastcall SetLabelVisible(bool Value);
	void __fastcall SetNumbersVisible(bool Value);
	void __fastcall SetNumbersPosition(ThlDipSwitchPanelNumbersPosition Value);
	
public:
	__fastcall ThlDipSwitchPanelLabels(void);
	__fastcall virtual ~ThlDipSwitchPanelLabels(void);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	
__published:
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	__property ThlDipSwitchPanelLabelPosition LabelPosition = {read=FLabelPosition, write=SetLabelPosition, default=0};
	__property bool LabelVisible = {read=FLabelVisible, write=SetLabelVisible, default=1};
	__property bool NumbersVisible = {read=FNumbersVisible, write=SetNumbersVisible, default=1};
	__property ThlDipSwitchPanelNumbersPosition NumbersPosition = {read=FNumbersPosition, write=SetNumbersPosition, default=0};
	__property AnsiString SwitchLabel = {read=FLabel, write=SetLabel};
};


class DELPHICLASS ThlDipSwitchPanelParams;
class PASCALIMPLEMENTATION ThlDipSwitchPanelParams : public ThlPanel 
{
	typedef ThlPanel inherited;
	
public:
	#pragma option push -w-inl
	/* ThlPanel.Create */ inline __fastcall ThlDipSwitchPanelParams(void) : ThlPanel() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~ThlDipSwitchPanelParams(void) { }
	#pragma option pop
	
};


class DELPHICLASS ThlDipSwitchPanel;
class PASCALIMPLEMENTATION ThlDipSwitchPanel : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	bool FAllowResize;
	int FInnerMargin;
	ThlDipSwitchPanelLabels* FLabels;
	int FNumSwitches;
	Classes::TNotifyEvent FOnChange;
	int FOuterMargin;
	ThlDipSwitchPanelParams* FPanelParams;
	AnsiString FSetting;
	int FSpacing;
	Classes::TList* FSwitchList;
	ThlDipSwitchWrapper* FSwitches;
	#pragma pack(push, 1)
	Types::TRect FSwitchesRect;
	#pragma pack(pop)
	
	int FNumbersHeight;
	void __fastcall CheckOSVersion(void);
	void __fastcall BuildSwitches(void);
	void __fastcall ChangeSwitchStates(AnsiString Value);
	void __fastcall ClearSwitchList(void);
	AnsiString __fastcall CreateSettingString(int Len);
	void __fastcall SetInnerMargin(int Value);
	void __fastcall SetLabels(ThlDipSwitchPanelLabels* Value);
	void __fastcall SetNumSwitches(int Value);
	void __fastcall SetOuterMargin(int Value);
	void __fastcall SetSetting(AnsiString Value);
	void __fastcall SetSpacing(int Value);
	
protected:
	virtual bool __fastcall CanResize(int &NewWidth, int &NewHeight);
	DYNAMIC void __fastcall ChangeScale(int M, int D);
	void __fastcall InitSwitches(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	void __fastcall PaintNumbers(void);
	void __fastcall PaintSwitchLabel(void);
	void __fastcall ParamsChanged(System::TObject* Sender);
	void __fastcall PositionItems(void);
	void __fastcall SwitchesChanged(System::TObject* Sender);
	void __fastcall SwitchStatesChanged(System::TObject* Sender);
	
public:
	__fastcall virtual ThlDipSwitchPanel(Classes::TComponent* AOwner);
	__fastcall virtual ~ThlDipSwitchPanel(void);
	virtual void __fastcall CreateWnd(void);
	
__published:
	__property ThlDipSwitchPanelLabels* Labels = {read=FLabels, write=SetLabels};
	__property int InnerMargin = {read=FInnerMargin, write=SetInnerMargin, nodefault};
	__property int NumSwitches = {read=FNumSwitches, write=SetNumSwitches, default=4};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property int OuterMargin = {read=FOuterMargin, write=SetOuterMargin, nodefault};
	__property ThlDipSwitchPanelParams* PanelParams = {read=FPanelParams, write=FPanelParams};
	__property AnsiString Setting = {read=FSetting, write=SetSetting};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=0};
	__property ThlDipSwitchWrapper* Switches = {read=FSwitches, write=FSwitches};
	__property Enabled  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property Visible  = {default=1};
	__property OnContextPopup ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall ThlDipSwitchPanel(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint InitLength = 0x14;
static const Shortint InitNumSwitches = 0x4;
static const Shortint InitNumPositions = 0x2;
static const Shortint InitPanelHeight = 0x64;
static const Shortint InitPanelInnerMargin = 0x5;
static const Shortint InitPanelOuterMargin = 0x5;
static const Byte InitPanelWidth = 0xc8;
static const Shortint InitRippleIndent = 0x1;
#define InitSetting "0000"
static const Shortint InitSpacing = 0x0;
static const Shortint InitSwitchHeight = 0x32;
static const Shortint InitSwitchMargin = 0x1;
static const Shortint InitSwitchWidth = 0x1e;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Hldipswitch */
using namespace Hldipswitch;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// hlDipSwitch
